#include "hexmanagerwidget.h"

CHexManagerWidget::CHexManagerWidget( QWidget *parent, const char *name,
				      bool showState )
  : QWidget( parent, name )
{
  mValid = false;

  mEditor = new CHexEditorWidget( this );
  if( mEditor == 0 ) { return; }
  
  mUtil = new CHexToolWidget( this );
  if( mUtil == 0 ) { return; }

  connect( mEditor->view(), SIGNAL( cursorChanged( SCursorState & ) ),
	   mUtil, SLOT( cursorChanged( SCursorState & ) ) );

  mValid      = true;
  mUtilHeight = 150;

  setShowUtil( showState );
  show();
}

CHexManagerWidget::~CHexManagerWidget( void )
{
  delete mEditor;
  delete mUtil;
}


void CHexManagerWidget::resizeEvent( QResizeEvent *e )
{
  if( mShowUtil == true )
  {
    mEditor->setGeometry( 0, 0, width(), height() - mUtilHeight );
    mUtil->setGeometry( 0, height() - mUtilHeight, width(), mUtilHeight );
  }
  else
  {
    mEditor->setGeometry( 0, 0, width(), height() );
  }
}


void CHexManagerWidget::setShowUtil( bool state )
{
  if( mValid == false ) { return; }

  mShowUtil = state;
  if( mShowUtil == true )
  {
    mEditor->setGeometry( 0, 0, width(), height() - mUtilHeight );
    mUtil->setGeometry( 0, height() - mUtilHeight, width(), mUtilHeight );
    mUtil->show();
  }
  else
  {
    mEditor->setGeometry( 0, 0, width(), height() );
    mUtil->hide();
  }
}





